set echo on

SELECT str
,      REGEXP_SUBSTR(str, '[^,]+', 1, LEVEL) AS single_element
,      LEVEL                                 AS element_no
FROM  (
       SELECT ROWNUM AS id
       ,      str
       FROM   t
      )
CONNECT BY INSTR(str, ',', 1, LEVEL-1) > 0
       AND id = PRIOR id
       AND PRIOR DBMS_RANDOM.VALUE IS NOT NULL;
